import { JsonViewer, JsonViewerOptions } from '@douyinfe/semi-json-viewer-core';
import BaseFoundation, { DefaultAdapter } from '../base/foundation';
export type { JsonViewerOptions };
export interface JsonViewerAdapter<P = Record<string, any>, S = Record<string, any>> extends DefaultAdapter<P, S> {
    getEditorRef: () => HTMLElement;
    getSearchRef: () => HTMLInputElement;
    notifyChange: (value: string) => void;
    notifyHover: (value: string, el: HTMLElement) => HTMLElement | undefined;
    setSearchOptions: (key: string) => void;
    showSearchBar: () => void;
}
declare class JsonViewerFoundation extends BaseFoundation<JsonViewerAdapter> {
    constructor(adapter: JsonViewerAdapter);
    jsonViewer: JsonViewer | null;
    init(): void;
    search(searchText: string): void;
    prevSearch(): void;
    nextSearch(): void;
    replace(replaceText: string): void;
    replaceAll(replaceText: string): void;
    setSearchOptions(key: string): void;
    showSearchBar(): void;
}
export default JsonViewerFoundation;
